
function Formatter(format = "")
{
    return new Base().setValues({ 
        "nsClass": "GXFormatter", 
        "format": format })
}

function ScaledFormatter(format = "%@", scale = 1, min = 0, max = 1)
{
    return Formatter(format).className("GXScaledFormatter").setValues({
        "min" : min,
        "max" : max,
        "scale" : scale
    })
}

function TimeFormatter(fractionalSeconds = false, format = "%@ seconds")
{
    return Formatter(format).className("GXTimeFormatter").setValues({  
        "fractionalSeconds": fractionalSeconds 
    })
}

function PercentageFormatter(scale = 100)
{
    return ScaledFormatter("%.0f%%", scale, 0, scale)
}

function NumberFormatter()
{
    return ScaledFormatter("%.0f%", 1, 0, 100000000000)
}